﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;

namespace Ads_Remover_for_Spotify
{
    class SongDiscover
    {

        public SongDiscover()
        {
            PopulateDesktopWindowsCaptions();
        }

        private List<string> windowTitles = new List<string>();

        public string Title { get { return GetTitle(); } }


        private string GetTitle()
        {
            var title = windowTitles.SingleOrDefault(x => x.StartsWith("Spotify"));
            return title == null ? "Spotify is closed" : title.Length == 7 ? "Nothing" : title.Substring(10).Trim();
        }

        const int MAXTITLE = 255;        

        private delegate bool EnumDelegate(IntPtr hWnd, int lParam);

        [DllImport("user32.dll", EntryPoint = "EnumDesktopWindows", ExactSpelling = false, CharSet = CharSet.Auto, SetLastError = true)]
        private static extern bool _EnumDesktopWindows(IntPtr hDesktop, EnumDelegate lpEnumCallbackFunction, IntPtr lParam);

        [DllImport("user32.dll", EntryPoint = "GetWindowText", ExactSpelling = false, CharSet = CharSet.Auto, SetLastError = true)]
        private static extern int _GetWindowText(IntPtr hWnd, StringBuilder lpWindowText, int nMaxCount);

        private bool EnumWindowsProc(IntPtr hWnd, int lParam)
        {
            string title = GetWindowText(hWnd);
            windowTitles.Add(title);
            return true;
        }

        /// <summary>
        /// Returns the caption of a windows by given HWND identifier.
        /// </summary>
        public static string GetWindowText(IntPtr hWnd)
        {
            StringBuilder title = new StringBuilder(MAXTITLE);
            title.Length = _GetWindowText(hWnd, title, title.Capacity + 1);
            return title.ToString();
        }

        /// <summary>
        /// Returns the caption of all desktop windows.
        /// </summary>
        public void PopulateDesktopWindowsCaptions()
        {
            EnumDelegate enumfunc = new EnumDelegate(EnumWindowsProc);
            IntPtr hDesktop = IntPtr.Zero; // current desktop
            _EnumDesktopWindows(hDesktop, enumfunc, IntPtr.Zero);
        }
    }
}
